# WaveWorks_example

Code sample for WaveWorks 2.x library

## Requirements

* Windows or Linux
* CMake 3.15
* C++ 17 compatible compiler

## Build

1. Create a build folder
   
   ex: ```<project root>/_build```

   **_Note:_** *it is highly recommended to generate the project files in a separate
   build folder ("out of core build") and not in the source tree directly.*

2. Configure CMake

   Two possibilities:

   * Use CMake's GUI:

     Make sure to set the path for `"Where to build the binaries"` to the build folder
     create in step [1.](#1)
     
     The UI will show all the available build options that enable or disable
     various components.

   * Use scripts or the command line:
     ```bash
     #!/bin/bash
     cmake_cmd="C:/Program\ Files/CMake/bin/cmake.exe"
     cmd="$cmake_cmd 
         -G 'Visual Studio 16 2019' -A x64 
         -DWAVEWORKS_BUILD_STATIC_LIB=ON 
         .."
     echo $cmd
     eval $cmd
     ```
   **_Note:_** *32 bits builds are not supported - make sure you configure the x64 architecture.*

3. Build the solution generated by CMake in the build folder

   * Load the solution in MSVC

   * From the command line:

     From the build folder, with MSVC as the compiler:
     ```bash
     C:/Program\ Files/CMake/bin/cmake.exe --build . --config Release --target All -- /v:minimal /m:12
     ```


